

#include <mega8.h>

#include <delay.h>

#include <1wire.h>
 #include <stdio.h>
 #include <stdlib.h>
#include <ds18b20.h>

#include <alcd.h>

#define ADC_VREF_TYPE ((0<<REFS1) | (0<<REFS0) | (0<<ADLAR))



#define set	    PIND.5
#define up	    PIND.6
#define down	PIND.7
char st[16];
char text[16];
eeprom int Max ;
eeprom int Min ;
void setting(void);
// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | ADC_VREF_TYPE;
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=(1<<ADSC);
// Wait for the AD conversion to complete
while ((ADCSRA & (1<<ADIF))==0);
ADCSRA|=(1<<ADIF);
return ADCW;
}


flash unsigned char char0[] = {0,0,16,8,4,8,16,0};  
flash unsigned char char1[] = {0,0,0,4,10,30,0,0};  
flash unsigned char char2[] = {0,4,4,4,4,7,0,0}; 

flash unsigned char char3[] = {2,0,7,5,7,31,0,0};   
flash unsigned char char4[] = {4,14,0,10,10,31,0,0};
 flash unsigned char char5[] = {4,4,4,4,4,7,0,0};
 flash unsigned char char6[] = {0,0,1,1,2,4,8,0};
 

void define_char(unsigned char flash *my_kalame ,unsigned char kaleme_to_karakter)
{
    unsigned char i,a;
    a=(kaleme_to_karakter<<3)|0x40;     
    for(i=0;i<=7;i++)           
        lcd_write_byte(a++ , *my_kalame++); 
        }
void main(void)
{
float Vout, P_kPa, P_milibar;
unsigned char i;
int d=0;

float Vs = 5; 

DDRB=(0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (0<<DDB2) | (0<<DDB1) | (0<<DDB0);

PORTB=(0<<PORTB7) | (0<<PORTB6) | (0<<PORTB5) | (0<<PORTB4) | (0<<PORTB3) | (0<<PORTB2) | (0<<PORTB1) | (0<<PORTB0);

DDRC=(0<<DDC6) | (0<<DDC5) | (0<<DDC4) | (0<<DDC3) | (0<<DDC2) | (0<<DDC1) | (0<<DDC0);

PORTC=(0<<PORTC6) | (0<<PORTC5) | (0<<PORTC4) | (0<<PORTC3) | (0<<PORTC2) | (0<<PORTC1) | (0<<PORTC0);
 
DDRD=(0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (1<<DDD3) | (1<<DDD2) | (0<<DDD1) | (1<<DDD0);

PORTD=(0<<PORTD7) | (0<<PORTD6) | (0<<PORTD5) | (0<<PORTD4) | (0<<PORTD3) | (0<<PORTD2) | (0<<PORTD1) | (0<<PORTD0);

// ADC initialization
// ADC Clock frequency: 500.000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=(1<<ADEN) | (0<<ADSC) | (0<<ADFR) | (0<<ADIF) | (0<<ADIE) | (0<<ADPS2) | (0<<ADPS1) | (1<<ADPS0);
SFIOR=(0<<ACME);

// 1 Wire Bus initialization
// 1 Wire Data port: PORTD
// 1 Wire Data bit: 1
// Note: 1 Wire port settings are specified in the
// Project|Configure|C Compiler|Libraries|1 Wire menu.
w1_init();

// Alphanumeric LCD initialization
// Connections are specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTB Bit 0
// RD - PORTB Bit 1
// EN - PORTB Bit 2
// D4 - PORTB Bit 4
// D5 - PORTB Bit 5
// D6 - PORTB Bit 6
// D7 - PORTB Bit 7
// Characters/line: 16
lcd_init(16);


   define_char(char0,0);
    define_char(char1,1);
    define_char(char2,2);
    define_char(char3,3);
    define_char(char4,4);
    define_char(char5,5);
    define_char(char6,6);
    
while (1)
      {
        d=ds18b20_temperature(0)  ;
      Vout = (float)read_adc(0)/1024*5;
      P_kPa = 5*(Vout/Vs-0.2);
      P_milibar = 10*P_kPa;

      for(i=0 ; i<50 ;i++)
      {
          if(set==1)setting();
          delay_ms(10);
      }   
      if(P_milibar>9+Max) PORTD.2=1;
      else  PORTD.2=0;
      
       if(P_milibar<Min-5) PORTD.3=1;
      else  PORTD.3=0;
      
      lcd_clear();
      lcd_gotoxy(0,0); 
         lcd_putchar(6);
       lcd_putchar(5);
       lcd_putchar(4);
        lcd_putchar(3);
       lcd_putsf(" =") ;
       ftoa(P_milibar,2,text);
      lcd_puts(text);
      lcd_putsf(" mBar");
       
     
      lcd_gotoxy(0,1); 
      
        lcd_putchar(2);
       lcd_putchar(1);
       lcd_putchar(0);
       lcd_putsf(" =");
      sprintf(st, "%02d",d); 
      lcd_puts(st);
      
      
      
      if(P_milibar>Max)
        PORTD.0=1;
        
      else if(P_milibar<Min)
        PORTD.0=0;   
      }
}




void setting(void)
{
    lcd_clear();
    lcd_gotoxy(0,0);
    lcd_puts("Set Min:");
    delay_ms(500);
    do
    {
        lcd_gotoxy(9,0);
        sprintf(text, "%03d",Min);
        lcd_puts(text);
        if(up==1)Min++;
        if(down==1)Min--;
        delay_ms(250);
    }while(set==0);
        
    lcd_gotoxy(0,1);
    lcd_puts("Set Max:");
    delay_ms(500);
    do
    {
        lcd_gotoxy(9,1);
        sprintf(text, "%03d",Max);
        lcd_puts(text);
        if(up==1)Max++;
        if(down==1)Max--;
        delay_ms(250);
    }while(set==0);  
    lcd_clear(); 
    delay_ms(250); 
}
